/* Copyright (C) 1994 by Computational Logic, Inc.  All Rights Reserved. */

/* This script is hereby placed in the public domain, and therefore unlimited */
/* editing and redistribution is permitted. */

/* NO WARRANTY */

/* Computational Logic, Inc. PROVIDES ABSOLUTELY NO WARRANTY.  THE EVENT SCRIPT */
/* IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, */
/* INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND */
/* FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND */
/* PERFORMANCE OF THE SCRIPT IS WITH YOU.  SHOULD THE SCRIPT PROVE DEFECTIVE, YOU */
/* ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. */

/* IN NO EVENT WILL Computational Logic, Inc. BE LIABLE TO YOU FOR ANY DAMAGES, */
/* ANY LOST PROFITS, LOST MONIES, OR OTHER SPECIAL, INCIDENTAL OR CONSEQUENTIAL */
/* DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THIS SCRIPT (INCLUDING BUT */
/* NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES */
/* SUSTAINED BY THIRD PARTIES), EVEN IF YOU HAVE ADVISED US OF THE POSSIBILITY OF */
/* SUCH DAMAGES, OR FOR ANY CLAIM BY ANY OTHER PARTY. */

#include <stdio.h>
#include <string.h>

int restlength(int currentline, FILE *fp)
{
  char line[513];

  while (fgets(line,512,fp) != NULL)
    currentline++;
  return(currentline);
}

void uncompress(char *filename)
{
  char syscom[215];

  strcpy(syscom,"uncompress ");
  strcat(syscom,filename);
  printf("\nUncompressing %s... ", filename);
  if (system(syscom)) {
    printf("Uncompress failed!!\n");
    exit (1);}
  else
    printf(" done.\n");
}

int nqthmdiff (char *filename1, char *filename2)
{
  long linenumber = 0;
  FILE *fp1 = fopen(filename1, "r");
  FILE *fp2 = fopen(filename2, "r");
  char line1[513];
  char line2[513];
  int status1, status2;
  int diff_count = 0;
  char tempname[200];

  if (fp1 == NULL) {
    strcpy(tempname,filename1);
    strcat(tempname,".Z");
    fclose(fp1);
    fp1 = fopen(tempname, "r");
    if (fp1 == NULL)
      return(-3);
    else {
      uncompress(tempname);
      fclose(fp1);
      fp1 = fopen(filename1, "r");}}

  if (fp2 == NULL) {
    strcpy(tempname,filename2);
    strcat(tempname,".Z");
    fclose(fp2);
    fp2 = fopen(tempname, "r");
    if (fp2 == NULL)
      return(-3);
    else {
      uncompress(tempname);
      fclose(fp2);
      fp2 = fopen(filename2, "r");}}

  status1 = (fgets(line1,512,fp1) != NULL);
  status2 = (fgets(line2,512,fp2) != NULL);

  while (status1 && status2) {
    linenumber++;
    if (strcmp(line1,line2) && ((line1[0] != '[') || (line2[0] != '['))) {
      diff_count++;
      printf("\nDifference encountered on line %d:\n\n",linenumber);
      printf("File %s:\n%s\n",filename1,line1);
      printf("File %s:\n%s\n",filename2,line2);
      /*return(linenumber)*/
      printf("Continuing....\n")
	;}
    status1 = (fgets(line1,512,fp1) != NULL);
    status2 = (fgets(line2,512,fp2) != NULL);}

  if (status1 != NULL)
    return (-1);
  else if (status2 != NULL)
    return (-2);
  else {
    printf("\nFiles %s and %s each have %d lines.\n",filename1, filename2,linenumber);
    return (diff_count);}
}

void main (int argc, char *argv[])
{
  long result;

  if (argc != 3) {
    printf("\nUsage:  nqthmdiff file1 file2\n");
    return;}
  printf("\n---------- Comparing %s with %s ----------\n",argv[1],argv[2]);
  result = nqthmdiff(argv[1],argv[2]);
  switch (result) {
  case -1:
    printf("\nFile %s ends early.\n",argv[2]);
    return;
  case -2:
    printf("\nFile %s ends early.\n",argv[1]);
    return;
  case -3:
    printf("\nFile %s does not exist.\n",argv[1]);
    return;
  case -4:
    printf("\nFile %s does not exist.\n",argv[2]);
    return;
  case 0:
    printf("\nThe files are identical except perhaps for time triples.\n");
    return;
  default:
    printf("\nFound differences on %d lines.\n", result);
  }
}
