#|

 Copyright (C) 1994 by Computational Logic, Inc.  All Rights Reserved.

 This script is hereby placed in the public domain, and therefore unlimited
 editing and redistribution is permitted.

 NO WARRANTY

 Computational Logic, Inc. PROVIDES ABSOLUTELY NO WARRANTY.  THE EVENT SCRIPT
 IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED,
 INCLUDING, BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES OF MERCHANTABILITY AND
 FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS TO THE QUALITY AND
 PERFORMANCE OF THE SCRIPT IS WITH YOU.  SHOULD THE SCRIPT PROVE DEFECTIVE, YOU
 ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

 IN NO EVENT WILL Computational Logic, Inc. BE LIABLE TO YOU FOR ANY DAMAGES,
 ANY LOST PROFITS, LOST MONIES, OR OTHER SPECIAL, INCIDENTAL OR CONSEQUENTIAL
 DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THIS SCRIPT (INCLUDING BUT
 NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES
 SUSTAINED BY THIRD PARTIES), EVEN IF YOU HAVE ADVISED US OF THE POSSIBILITY OF
 SUCH DAMAGES, OR FOR ANY CLAIM BY ANY OTHER PARTY.
|#

(IN-PACKAGE "USER")

(EVAL-WHEN (LOAD EVAL COMPILE)
	   (CHK-BASE-AND-PACKAGE-1992 10 *PACKAGE*))

(defun translate-reader (stream subchar arg)
  (declare (ignore subchar arg))
  (let* ((form (read stream t nil t)))
    (translate form)))

(set-dispatch-macro-character #\# #\t #'translate-reader)

(let ((*readtable* (nqthm-readtable)))
  (set-dispatch-macro-character #\# #\t #'translate-reader
				 *readtable*))

(defparameter *mods-alist*
  (if (boundp '*mods-alist*)		;so it can work with Nqthm-1987
      (if (not (assoc-eq 'sharp-t-reader *mods-alist*))
	  (cons (cons 'sharp-t-reader
		      "This `#t' reader' causes the Nqthm translator to be
called at read time on any expression #t<form> or #T<form>.
To illustrate a typical use:  if you type

     (EVAL$ T '#T(LIST X) (CONS 'X X))

then this will be read as though you had typed

     (EVAL$ T '(CONS X 'NIL) (CONS 'X X))

That is:  (LIST X) was translated to (CONS X 'NIL), so you can imagine
that #T(LIST X) was read in as (CONS X 'NIL), and hence '#T(LIST X)
was read in as '(CONS X 'NIL).  Since EVAL$'s semantics don't ascribe
any real meaning to LIST, this insertion of #T is useful for typing
what you really mean in such cases.  See also \"translate-reader.doc\~.")
		*mods-alist*)
	*mods-alist*)
    nil))
